<<<<<<< .mine
jabberFu = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceHook-2.1", "FuBarPlugin-2.0")
jabberFu.hasIcon = "Interface\\GossipFrame\\PetitionGossipIcon"
jabberFu.cannotDetachTooltip = true
jabberFu.hasNoColor = true
local L = AceLibrary("AceLocale-2.2"):new("jabberFu")
L:RegisterTranslations("enUS", function() return({
	enabled = true,
		enabled_desc = "enable / disable",
}) end)
--
function jabberFu:OnInitialize()
	self.buttonHooks = {
		"ScrollToBottom",
		"ScrollToTop",
		"ScrollDown",
		"ScrollUp",
		"PageDown",
		"PageUp"
	}
	self.stickyChannels = {
		"SAY",
		"YELL",
		"EMOTE",
		"PARTY",
		"RAID",
		"RAID_LEADER",
		"RAID_WARNING",
		"GUILD",
		"OFFICER",
		"WHISPER",
		"REPLY",
		"CHANNEL"
	}
	self.defaults = {
		buttonHide = true,
		editTop = true,
		replaceChat = {
			guild = "[G] %s:\32",
			party = "[P] %s:\32",
			raid = "[R] %s:\32",
			say = "[S] %s:\32",
			whisper = "[W] %s:\32"
		},
		replaceChannel = {
			["%[(%d)%. General%]"] = "[%1.GN]",
			["%[(%d)%. LocalDefense%]"] = "[%1.LD]",
			["%[(%d)%. Trade%]"] = "[%1.TR]",
			["%[(%d)%. GuildRecruitment%]"] = "[%1.GR]"
		},
		scrollLines = 2,
		scrollEnd = IsModifierKeyDown,
		sticky = {},
		timestring = "|c00cc9933{%H:%M}|r "
	}
	self.options = {
		type = 'group', args={
			buttonHide={
				type="toggle", name="button hide", desc="button hide",
				get=function() return(self.db.profile.buttonHide) end,
				set=function(x) self.db.profile.buttonHide=x self:UpdateButtons() end
			},
			editTop={
				type="toggle", name="edit top", desc="edit top",
				get=function() return(self.db.profile.editTop) end,
				set=function(x) self.db.profile.editTop=x self:UpdateEditBox() end
			},
			replace={
				type="group", name="replace", desc="replace",
				args={
					chat={
						type="group", name="chat", desc="chat",
						args={
							guild={
								type="text", name="guild", desc="guild",
								get=function() return(self.db.profile.replaceChat.guild) end,
								set=function(x) self.db.profile.replaceChat.guild=x end,
								usage=""
							},
							party={
								type="text", name="party", desc="party",
								get=function() return(self.db.profile.replaceChat.party) end,
								set=function(x) self.db.profile.replaceChat.party=x end,
								usage=""
							},
							raid={
								type="text", name="raid", desc="raid",
								get=function() return(self.db.profile.replaceChat.raid) end,
								set=function(x) self.db.profile.replaceChat.raid=x end,
								usage=""
							},
							say={
								type="text", name="say", desc="say",
								get=function() return(self.db.profile.replaceChat.say) end,
								set=function(x) self.db.profile.replaceChat.say=x end,
								usage=""
							},
							whisper={
								type="text", name="whisper", desc="whisper",
								get=function() return(self.db.profile.replaceChat.whisper) end,
								set=function(x) self.db.profile.replaceChat.whisper=x end,
								usage=""
							}
						}
					},
					channel={
						type="group", name="channel", desc="channel",
						args={}
					}
				}
			},
			scrollLines={
				type="range", name="scroll lines", desc="scroll lines",
				min=1, max=6, step=1,
				get=function() return(self.db.profile.scrollLines) end,
				set=function(x) self.db.profile.scrollLines=x end
			},
			sticky = {
				type="group", name="sticky", desc="sticky",
				args={}
			},
			timestamp={
				type="text", name="timestamp", desc="timestamp",
				get=function() return(self.db.profile.timestring:gsub('|','||')) end,
				set=function(x) self.db.profile.timestring=x:gsub('||','|') end,
				usage="the time format string"
			}
		}
	}
	for k, v in pairs(self.stickyChannels) do
		self.defaults.sticky[v] = not ChatTypeInfo[v].sticky == 0
		self.options.args.sticky.args[v] = {
			type="toggle", order=k, name=v, desc=v,
			get=function() return(self.db.profile.sticky[v]) end,
			set=function(x)
				if(x) then
					ChatTypeInfo[v].sticky = 1
				else
					ChatTypeInfo[v].sticky = 0
				end
				self.db.profile.sticky[v] = x
			end
		}
	end
	self:RegisterDB("jabberFuDB")
	self:RegisterDefaults("profile", self.defaults)
	self.OnMenuRequest = self.options
end
--
function jabberFu:OnEnable()
	self:UpdateButtons()
	self:UpdateChat()
	self:UpdateEditBox()
	self:UpdateScroll()
	self:Hook(DEFAULT_CHAT_FRAME, "AddMessage")
end
--
function jabberFu:UpdateButtons()
	local p = self.db.profile
	if(p.buttonHide) then
		ChatFrameMenuButton:Hide()
	else
		ChatFrameMenuButton:Show()
	end
	for i = 1, 7 do
		local f = getglobal("ChatFrame"..i)
		local bb = getglobal("ChatFrame"..i.."BottomButton")
		if(p.buttonHide) then
			for _, m in pairs(self.buttonHooks) do
				f["jab"..m] = f[m]
				f[m] = function()
					f["jab"..m](f)
					if(f:AtBottom()) then
						bb:Hide()
					else
						bb:Show()
					end
				end
			end
			bb:ClearAllPoints()
			bb:SetPoint("BOTTOMRIGHT", f, 0, -4)
			bb:SetAlpha(0.6)
			bb:Hide()
			getglobal("ChatFrame"..i.."DownButton"):Hide()
			getglobal("ChatFrame"..i.."UpButton"):Hide()
		elseif(f.jabScrollToBottom) then
			for _, m in pairs(self.buttonHooks) do
				f[m] = f["jab"..m]
				f["jab"..m] = nil
			end
			bb:ClearAllPoints()
			bb:SetPoint("BOTTOMLEFT", f, -32, -4)
			bb:SetAlpha(1)
			bb:Show()
			getglobal("ChatFrame"..i.."DownButton"):Show()
			getglobal("ChatFrame"..i.."UpButton"):Show()
		end
	end
end
--
function jabberFu:UpdateChat()
	local p = self.db.profile
	local c = self.options.args.replace.args.channel.args
	local i = 1
	c = {}
	for k, _ in pairs(p.replaceChannel) do
		c[tostring(i)]={
			type="text", name=k, desc=k,
			get=function() return(p.replaceChanel[k]) end,
			set=function(x) p.replaceChanel[k]=x end,
			usage=""
		}
		i = i + 1
	end
	CHAT_GUILD_GET = p.replaceChat.guild
	CHAT_PARTY_GET = p.replaceChat.party
	CHAT_RAID_GET = p.replaceChat.raid
	CHAT_SAY_GET = p.replaceChat.say
	CHAT_WHISPER_GET = p.replaceChat.whisper
	for _, i in pairs(self.stickyChannels) do
		if(p.sticky[i]) then
			ChatTypeInfo[i].sticky = 1
		else
			ChatTypeInfo[i].sticky = 0
		end
	end
end
--
function jabberFu:UpdateEditBox()
	ChatFrameEditBox:ClearAllPoints()
	if(self.db.profile.editTop) then
		ChatFrameEditBox:SetPoint("BOTTOMLEFT",  ChatFrame1, "TOPLEFT",  -5, 2)
		ChatFrameEditBox:SetPoint("BOTTOMRIGHT",  ChatFrame1, "TOPRIGHT",  5, 2)
	else
		ChatFrameEditBox:SetPoint("TOPLEFT",  ChatFrame1, "BOTTOMLEFT",  -5, -2)
		ChatFrameEditBox:SetPoint("TOPRIGHT",  ChatFrame1, "BOTTOMRIGHT",  5, -2)
	end
end
--
function jabberFu:UpdateScroll()
	local p = self.db.profile
	for i = 1, 7 do
		local f = getglobal("ChatFrame"..i)
		f:EnableMouseWheel(true)
		f:SetScript("OnMouseWheel", function()
			if(arg1 > 0) then
				if(p:scrollEnd()) then
					this:ScrollToTop()
				else
					for i = 1, p.scrollLines do this:ScrollUp() end
				end
			else
				if(p:scrollEnd()) then
					this:ScrollToBottom()
				else
					for i = 1, p.scrollLines do this:ScrollDown() end
				end
			end
		end)
	end

end
--
function jabberFu:AddMessage(frame, text, r, g, b, id)
	if(text) then
		for k, v in pairs(self.db.profile.replaceChannel) do
			text = text:gsub(k, v)
		end
		text = date(self.db.profile.timestring)..text
		self.hooks[frame].AddMessage(frame, text, r, g, b, id)
	end
=======
jabberFu = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceHook-2.1", "FuBarPlugin-2.0")
jabberFu.hasIcon = "Interface\\GossipFrame\\PetitionGossipIcon"
jabberFu.cannotDetachTooltip = true
jabberFu.hasNoColor = true
local L = AceLibrary("AceLocale-2.2"):new("jabberFu")
L:RegisterTranslations("enUS", function() return({
	enabled = true,
		enabled_desc = "enable / disable",
}) end)
--
function jabberFu:OnInitialize()
	self.stickyChannels = {
		"SAY",
		"YELL",
		"EMOTE",
		"PARTY",
		"RAID",
		"RAID_LEADER",
		"RAID_WARNING",
		"GUILD",
		"OFFICER",
		"WHISPER",
		"REPLY",
		"CHANNEL"
	}
	self.defaults = {
		buttonHide = false,
		editTop = false,
		scroll = true,
		scrollLines = 2,
		scrollEnd = IsModifierKeyDown,
		sticky = {},
		timestamp = true,
		timestring = "|c00cc9933{%H:%M}|r "
	}
	self.options = {
		type = 'group', args={
			buttons={
				type="group", name="buttons", desc="butons",
				args={
					hide={
						type="toggle", name="hide", desc="hide",
						get=function() return(self.db.profile.buttonHide) end,
						set=function(x) self.db.profile.buttonHide=x self:UpdateButtons() end
					}
				}
			},
			editTop={
				type="toggle", name="edit top", desc="edit top",
				get=function() return(self.db.profile.editTop) end,
				set=function(x) self.db.profile.editTop=x self:UpdateEditBox() end
			},
			scroll={
				type="group", name="scroll", desc="scroll",
				args={
					enabled={
						type="toggle", name=L.enabled, desc=L.enabled_desc,
						get=function() return(self.db.profile.scroll) end,
						set=function(x) self.db.profile.scroll=x self:UpdateScroll() end
					},
					lines={
						type="range", name="lines", desc="lines",
						min=1, max=6, step=1,
						get=function() return(self.db.profile.scrollLines) end,
						set=function(x) self.db.profile.scrollLines=x end
					}
				}
			},
			sticky = {
				type="group", name="sticky", desc="sticky",
				args={}
			},
			timestamp={
				type="group", name="timestamp", desc="timestamp",
				args={
					enable={
						type="toggle", name=L.enabled, desc=L.enabled_desc,
						get=function() return(self.db.profile.timestamp) end,
						set=function(x) self.db.profile.timestamp=x end
					},
					string={
						type="text", name="string", desc="string",
						get=function() return(self.db.profile.timestring:gsub('|','||')) end,
						set=function(x) self.db.profile.timestring=x:gsub('||','|') end,
						usage="the time format string"
					}
				}
			}
		}
	}
	for k, v in pairs(jabberFu.stickyChannels) do
		self.defaults.sticky[v] = not ChatTypeInfo[v].sticky == 0
		self.options.args.sticky.args[v] = {
			type="toggle", order=k, name=v, desc=v,
			get=function() return(jabberFu.db.profile.sticky[v]) end,
			set=function(x)
				if(x) then
					ChatTypeInfo[v].sticky = 1
				else
					ChatTypeInfo[v].sticky = 0
				end
				self.db.profile.sticky[v] = x
			end
		}
	end
	self:RegisterDB("jabberFuDB")
	self:RegisterDefaults("profile", self.defaults)
	self.OnMenuRequest = self.options
end
--
function jabberFu:OnEnable()
	local p = self.db.profile
	self:Hook(DEFAULT_CHAT_FRAME, "AddMessage")
	self:UpdateButtons()
	self:UpdateEditBox()
	self:UpdateScroll()
	for _, i in pairs(self.stickyChannels) do
		if(p.sticky[i]) then
			ChatTypeInfo[i].sticky = 1
		else
			ChatTypeInfo[i].sticky = 0
		end
	end
end
--
function jabberFu:UpdateButtons()
	local p = self.db.profile
	if(p.buttonHide) then
		ChatFrameMenuButton:Hide()
	else
		ChatFrameMenuButton:Show()
	end
	for i = 1, 7 do
		local f = getglobal("ChatFrame"..i)
		local bb = getglobal("ChatFrame"..i.."BottomButton")
		if(p.buttonHide) then
			f.jabScrollToBottom = f.ScrollToBottom
			f.ScrollToBottom = function()
				f:jabScrollToBottom()
				bb:Hide()
			end
			bb:ClearAllPoints()
			bb:SetPoint("BOTTOMRIGHT", f, 0, -4)
			bb:Hide()
			getglobal("ChatFrame"..i.."DownButton"):Hide()
			getglobal("ChatFrame"..i.."UpButton"):Hide()
		else
			f.ScrollToBottom = f.jabScrollToBottom
			f.jabScrollToBottom = nil
			bb:ClearAllPoints()
			bb:SetPoint("BOTTOMLEFT", f, -32, -4)
			bb:Show()
			getglobal("ChatFrame"..i.."DownButton"):Show()
			getglobal("ChatFrame"..i.."UpButton"):Show()
		end
	end
end
--
function jabberFu:UpdateEditBox()
	local p = self.db.profile
	ChatFrameEditBox:ClearAllPoints()
	if(p.editTop) then
		ChatFrameEditBox:SetPoint("BOTTOMLEFT",  ChatFrame1, "TOPLEFT",  -5, 2)
		ChatFrameEditBox:SetPoint("BOTTOMRIGHT",  ChatFrame1, "TOPRIGHT",  5, 2)
	else
		ChatFrameEditBox:SetPoint("TOPLEFT",  ChatFrame1, "BOTTOMLEFT",  -5, -2)
		ChatFrameEditBox:SetPoint("TOPRIGHT",  ChatFrame1, "BOTTOMRIGHT",  5, -2)
	end
end
--
function jabberFu:UpdateScroll()
	local p = self.db.profile
	for i = 1, 7 do
		local f = getglobal("ChatFrame"..i)
		if(p.scroll) then
			f:EnableMouseWheel(true)
			f:SetScript("OnMouseWheel", function() self:ChatScroll(arg1) end)
		else
			f:EnableMouseWheel(false)
			f:SetScript("OnMouseWheel", nil)
		end
	end

end
--
function jabberFu:ChatScroll(x)
	local p = self.db.profile
	if(x > 0) then
		if(p:scrollEnd()) then
			this:ScrollToTop()
		else
			for i = 1, p.scrollLines do this:ScrollUp() end
		end
	else
		if(p:scrollEnd()) then
			this:ScrollToBottom()
		else
			for i = 1, p.scrollLines do this:ScrollDown() end
		end
	end
	if(this:AtBottom()) then
		getglobal(this:GetName().."BottomButton"):Hide()
	else
		getglobal(this:GetName().."BottomButton"):Show()
	end
end
--
function jabberFu:AddMessage(frame, text, r, g, b, id)
	local p = self.db.profile
	if(text) then
		if(p.timestamp) then
			text = date(p.timestring)..text
		end
	end
	self.hooks[frame].AddMessage(frame, text, r, g, b, id)
>>>>>>> .r26170
end